Program ExDBase;                { Simple database application }
Uses Crt,Printer;                             { (c) jskl 1997 }

{ Random access files have records numbered from 0:  0 1 2 ....
  One record is always the current one, its number is stored
  in the file pointer.
  After opening (Reset,Rewrite) file pointer is cleared to 0.

  Routines:
   Function FilePos(F):Integer   returns the current file pointer.
   Function FileSize(F):Integer  returns the number of records.
                                 (last record number + 1)
   Procedure Seek(F,n)           places pointer to the n-th record
   Procudre Truncate(F)          truncates past the current pointer
                                 (the rest including current deleted).
   Read(F,p)                     reads current record to p
   Write(F,p)                    writes p to current record

  Appending a record:
   Seek(F,Filesize(F); Write(F,p)

  Deleting a record:
   - Overwrite the record by the last one
   - Truncate the last one
   - Sort the file if necessary }

Const    NameLenght = 20;
         DFName = 'data';                 { Default file name }

Type     NameType = String[NameLenght];

         Date = record
                 Day   : 1..31;
                 Month : 1..12;
                 Year  : 1850..2100;
                end;

         Person=record
                 Name,Surname : NameType;
                 BirthDate    : Date;
                 Sex          : Char;
                 Salary       : Real;
                 ID           : String[8];
                 Phone        : String[20];
                 { Add more if necessary }
                end;

Var F        : File of Person;      { Global variables }
    Filename : String[50];                 { File name }
    Option   : Char;                { Main menu option }
    Opened   : Boolean;            { True if file open }

{***************************************************************}

Procedure DispMenu;      { Displays the main menu }
Begin
     TextBackground(Black);
     ClrScr;
     TextColor(Yellow);
     GoToXY(32,3); Write('MODEL DATABASE');
     TextColor(LightGreen);
     GoToXY(32,6);  Write('O....Open File');
     GoToXY(32,8);  Write('A....Add Record');
     GoToXY(32,10); Write('U....Update Record');
     GoToXY(32,12); Write('D....Delete Record');
     GoToXY(32,14); Write('S....Show List');
     GoToXY(32,16); Write('P....Print List');
     GoToXY(32,18); Write('R....Sorting File');
     GoToXY(32,20); Write('Q....Quit');
     TextColor(Yellow);
     GoToXY(30,23); Write('Press a key to select');
End{DispMenu};

{***************************************************************}

Function ErrorName(Code:Integer):String;
Begin
 Case Code of
    2: ErrorName:='File not found';
    3: ErrorName:='Path not found';
    4: ErrorName:='Too many open files';
  103: ErrorName:='File not open';
  150: ErrorName:='Disk is write protected';
  152: ErrorName:='Drive not ready';
  else ErrorName:='Unknown error'
 end
End;

{***************************************************************}

Procedure Warning;
Begin
  ClrScr;
  GoToXY(20,10);
  Write('File not open! Press Enter and open a file.');
  ReadLn
End;

{***************************************************************}

Procedure DispPerson(p:Person);  { Displays the record p }
Begin
   With p do begin
      GoToXY(3,3); Write('Name: ',Name);
      GoToXY(3,4);
      With Birthdate do
        Write('Born: ',Day,'/',Month,'/',Year);
      GoToXY(3,5); Write('Sex:  ',Sex);
      GoToXY(32,3);Write('Surname: ',Surname);
      GoToXY(32,4);Write('Salary:  ',Salary:6:2);
      GoToXY(32,5);Write('Phone:   ',Phone);
      GoToXY(60,3);Write('ID: ',ID);
   end{with};
End{DispPerson};

{***************************************************************}

Procedure ReadPerson(Var p:Person); { Reading fields of p }
Begin
  With p do begin
     ClrScr;
     GoToXY(10,5); Write('Enter Name: ');ReadLn(Name);
     GoToXY(10,6); Write('Enter SurName: ');ReadLn(SurName);
     GoToXY(10,9); Write('Enter Birthdate day: ');ReadLn(Birthdate.day);
     GoToXY(10,10);Write('Enter Birthdate month: ');ReadLn(Birthdate.month);
     GoToXY(10,11);Write('Enter Birthdate year: ');ReadLn(Birthdate.year);
     Repeat
       GoToXY(10,13); Write('Enter Sex (F/M): ');
       Sex := UpCase(ReadKey); Write(Sex)
     Until Sex in ['F','M'];
     GoToXY(10,14);Write('Enter Salary: ');ReadLn(Salary);
     GoToXY(10,15);Write('Enter ID/Passport number: ');ReadLn(ID);
     GoToXY(10,16);Write('Enter Phone number: ');ReadLn(Phone);
  end{with}
End{ReadPerson};

{***************************************************************}

Procedure Surname_Search(Surn:String; Var Posi:Integer; Var Foundit:Boolean);
{ Sequential search for the surname Surn in F starting from the position
  Posi. If found, Foundit is true and position in Posi. Otherwise Foundit
  is false. }
Var Per:Person;
Begin
   FoundIt := false;
   While (Posi+1<=FileSize(F)) and not FoundIt do begin
      Seek(F,Posi); Read(F,Per);
      FoundIt:=(Per.Surname=Surn);
      If not FoundIt then Inc(Posi)
   end{While}
End;

{***************************************************************}

Procedure By_screen;
Begin
   ClrScr;
   GoToXY(36,12); Write('Good Bye !');
   Delay(1000);
   { Any other show here }
End;

{********************* Main menu procedures *********************}

Procedure OpenFile;    { Prepares a file for work }
Var IORes:Integer; c:Char;
Begin
    If Opened then Close(F);
    Opened := false;
    ClrScr; WriteLn ('Enter the file name:');
    ReadLn(Filename); WriteLn;
    Assign (F,Filename);
    {$I-} Reset(F); {$I+}       { Attempt to open }
    IORes:=IOResult;    { Storing the result code }
    If IORes = 0 then begin                  { OK }
       Write ('File ',Filename,' open. Press enter to continue.');
       ReadLn;
       Opened:=true
     end
    Else If IORes = 2 then begin  { File not found }
         WriteLn('The file ',Filename,' not found.');
         WriteLn('Do you want to create it?  (Y/N)');
         Repeat c:=UpCase(ReadKey) until c in ['Y','N'];
         If c='Y'then begin      { nothing for 'N' }
            {$I-} Rewrite(F); {$I+}
            IORes:=IOResult;
            If IORes = 0 then Opened:=true
            Else begin
               WriteLn('Error creating the file ',FileName);
               WriteLn('Error: ',IORes,' ',ErrorName(IORes));
               WriteLn('Press enter and try again.');
               ReadLn
            end {creating file}
         end {'Y'}
      end {IORes=2}
    Else begin               { Other opening error }
      WriteLn('File ',FileName,' cannot be open.');
      WriteLn('Error:',IORes,' ',ErrorName(IORes));
      WriteLn('Press enter and try again.');ReadLn
    End
End{OpenFile};

{*****************************************************************}

Procedure Add; { Adds a new record to F }
Var p:Person;
Begin
   If not Opened then Warning
   Else begin
      ReadPerson(p); { Reads record to p (to RAM) }
      Seek(F,FileSize(F));
      Write(F,p);
      GoToXY(10,3);
      Write('Now there are ',FileSize(F),' records in the file ',Filename);
      ReadLn;
  end{if}
End{Add};

{*****************************************************************}

Procedure Update;            { Interactive Editing }
  Var Position:Integer; p:Person; Option:char;

  Procedure UpdateMenu; { Local Update menu }
  Begin
     TextColor(white);
     GoToXY(32,8);  Write('N....Next');
     GoToXY(32,10); Write('P....Previous');
     GoToXY(32,12); Write('T....Top');
     GoToXY(32,14); Write('B....Bottom');
     GoToXY(32,16); Write('S....Search');
     GoToXY(32,18); Write('E....Edit');
     GoToXY(32,20); Write('M....Main menu');
     TextColor(green);
     GoToXY(32,23); Write('Press a key to select');
  End;

  Procedure Editing; { Local procedure }
   Var d:Char;

   Procedure EditMenu;
   Begin
     TextColor(white);
     GoToXY(32,8);  Write('N....Name');
     GoToXY(32,10); Write('S....Surname');
     GoToXY(32,12); Write('B....Birthdate');
     GoToXY(32,14); Write('X....Sex');
     GoToXY(32,16); Write('R....Salary');
     GoToXY(32,18); Write('I....ID/Passport');
     GoToXY(32,20); Write('P....Phone');
     GoToXY(32,22); Write('U....Update menu');
     TextColor(green);
     GoToXY(32,25); Write('Press a key to select');
   End;

  Begin
    Repeat
       ClrScr;
       GoToXY(3,1);Write('Editing record number ',Position);
       DispPerson(p);
       EditMenu;
       Repeat
          d:=UpCase(ReadKey)
       Until d in ['N','S','B','X','R','I','P','U'];
       With p do
         Case d of
         'N':begin
              GoToXY(1,24); Write('Enter new name: ');
              ReadLn(Name)
             end;
         'S':begin
              GoToXY(1,24); Write('Enter Surname: ');
              ReadLn(Surname)
             end;
         'B':begin
              GoToXY(1,24); Write('Enter Day of birthdate: ');
              ReadLn(Birthdate.day);
              GoToXY(1,24); ClrEol; Write('Enter Month of birthdate: ');
              ReadLn(Birthdate.month);
              GoToXY(1,24); ClrEol; Write('Enter Year of birthdate: ');
              ReadLn(Birthdate.Year);
             end;
         'X':Repeat
              GoToXY(1,24); Write('Enter Sex (F/M): ');
              Sex := UpCase(ReadKey); Write(Sex)
             Until Sex in ['F','M'];
         'R':begin
              GoToXY(1,24); Write('Enter Salary: ');
              ReadLn(Salary)
             end;
         'I':begin
              GoToXY(1,24); Write('Enter ID/Passport No: ');
              ReadLn(ID)
             end;
         'P':begin
              GoToXY(1,24); Write('Enter Phone No: ');
              ReadLn(Phone)
             end;
         end{case}
      Until d='U';
      Seek(F,Position); Write(F,p);   { Updating in F }
  End{Editing};

  Procedure Searching;
  Var SN:String; Pos:Integer; Found:Boolean;
      sp:Person; c:Char;
  Begin
   c:='C'; Pos:=0; ClrScr; GoToXY(5,5);
   Write('Enter surname to search for: ');
   ReadLn(SN);
   Repeat
      Surname_Search(SN,Pos,Found); { Searching in F for SN }
      If found then begin
         Seek(F,Pos); Read(F,sp); ClrScr;
         DispPerson(sp); GoToXY(10,23);
         Write('Is this the record you search for? (Y)es (C)ontinue (Q)uit');
         Repeat c:=UpCase(ReadKey) until c in ['Y','C','Q'];
         If c='Y' then begin Position:=Pos; p:=sp end;
         Inc(Pos);
      end{if found};
   Until(c in ['Y','Q']) or not found;
   If not found then begin
         GoToXY(10,23);
         Write('No(more) records with surname ',SN,' Press Enter');
         ReadLn
   end{if}
  End{Searching};

Begin{body of Update}
   If not Opened then Warning
   Else begin
      ClrScr; Position:=0;
      Read(F,p);
      Repeat
         ClrScr;
         GoToXY(3,1);Write('Record number ',Position);
         DispPerson(p);
         UpdateMenu;
         Repeat Option:=UpCase(ReadKey) Until Option in ['N','P','T','B','S','E','M'];
         Case option of
        'N':If Position=Filesize(F)-1 then begin
                ClrScr;GoToXY(10,10);
                Write('Already at the end!  Press Enter!');
                ReadLn
              end
            Else begin
                Inc(Position);
                Seek(F,Position);
                Read(F,p);
            end;
        'P':If Position=0 then begin
                ClrScr;GoToXY(10,10);
                Write('Already at the first record!  Press Enter!');
                ReadLn
               end
            Else begin
                Dec(Position);
                Seek(F,Position);
                Read(F,p);
            end;
        'T':begin
               Position:=0;
               Seek(F,Position);
               Read(F,p);
              end;
        'B':begin
               Position:=FileSize(F)-1;
               Seek(F,Position);
               Read(F,p);
             end;
        'S':Searching;
        'E':Editing;
        end{case}
      Until Option='M';
   end{if}
End;

{*****************************************************************}

Procedure Delete;
Var SN:String; Pos:Integer; Found:Boolean;
    sp:Person; c:Char;
Begin
  If not Opened then Warning
  Else begin
     ClrScr; GoToXY(5,5); Pos:=0; c:=' ';
     Write ('Enter Surname to Delete: '); Readln (SN);
     Repeat
        Surname_Search (SN, Pos, Found); {Searching in F for Sn}
        If found then begin
           Seek (F,Pos); Read (F,sp); ClrScr;
           DispPerson (sp); GoToXY(2,22);
           Write ('Is this the Record you want to delete?',
                  '    (Y)es  (C)ontinue  (Q)uit');
           Repeat c:=Upcase(Readkey) until c in ['Y','C','Q'];
           If c='C' then Inc(Pos);
        end;
     Until (c in ['Y','Q']) or not Found or (Pos>FileSize(F)-1);

     If c='Y' then begin                     { Deleting }
        Seek(F,FileSize(F)-1);    { Reading last record }
        Read(F,sp);
        Seek(F,Pos);    { Overwrite current by last one }
        Write(F,sp);
        Seek(F,FileSize(F)-1);
        Truncate(F);             { Truncate last record }
        GoToXY(2,22); ClrEol;
        Write ('The record has been deleted. Now there are ',
               FileSize(F),' records in ', Filename, '.  Press Enter');
        readln
     end {if} ;

     If not (c in ['Y','Q']) then begin
        GoToXY(10,12);
        Write ('No (more) records with the Surname ', SN,
               '... Press Enter to Continue');
        ReadLn;
     end {if} ;
  end{if};
End{Delete};

{*****************************************************************}

Procedure Show;              { Displays list of records }
Var p:Person;Max,i,First,Last,Line:Integer; c:Char;
Begin
   If not Opened then Warning
   Else begin
     ClrScr;
     Max:=FileSize(F);        { Total number of records }
     Writeln;
     WriteLn(' There are ',Max,' records in the file ',FileName);
     Writeln;
     Write(' Enter the record number to start with: ');
     ReadLn(First);
     {From user's view the first record has number 1 !!!}
     If First<1 then First:=1
     Else IF First>Max then First:=Max;
     Write(' Enter the number of the last record shown: ');
     ReadLn(Last);
     If Last<First then Last:=First
     Else If Last>Max then Last:=Max;
     { Heading: }
     ClrScr;
     WriteLn(' No Name          Surname        Born      Sex    ID        Salary      Phone');
     For i:=1 to 77 do Write('=');WriteLn;
     Line:=3;
     For i:=First to Last do begin
          Seek(F,i-1);
          Read(F,p);
          With p do begin
            Write(i:3,' ');
            Write(Name);
            GoToXY(19,Line);
            Write(SurName);
            GoToXY(30,Line);
            With Birthdate do
               Write(Day:5,'/',Month:2,'/',Year:4,' ');
            If UpCase(Sex)='F' then Write('Female')
                               else Write('Male  ');
            GoToXY(51,Line);
            Write(ID:5);
            GoToXY(59,Line);
            Write(Salary:8:1,'  ');
            GoToXY(67,Line);
            WriteLn(Phone:11);
          end{with};
          Inc(Line);
          If(i mod 20)=0 then begin
            WriteLn('-More-  Press Enter to continue');
            ReadLn;
            Line:=1;
          End;
     end{for};
     WriteLn;
     Write('Press Enter to continue');
     ReadLn;
     Seek(F,0);
   end{if};
End;

{*****************************************************************}

Procedure Print;     { Prints a list of Records }
Var p:Person; Max,i,First,Last,lines: Integer; C:Char;
    Test:String[15];
    temp2:String[8];
Begin
     If not Opened then Warning
     Else Begin
          ClrScr;
          Max:=FileSize(F);     { Total number of records }
          Writeln;
          Writeln (' There are ',Max,' records in the file ',FileName);
          Writeln;
          Write (' Enter the Number of the First Record to show: ');
          Readln(First);
          {From users view the first record has number 1!!!}
          If First<1 then First:=1
          else if First>Max then First:=Max;
          Write (' Enter the Number of the Last Record to show: ');
          Readln(Last);
          If Last<First then Last:=First
          Else If Last>Max then Last:=Max;
          { Heading: }
Writeln(Lst,{#12,}'No. Name           Surname          Born      Sex    Id       Salary    Phone');
          For i:=1 to 78 do Write(Lst,'='); Writeln(Lst);
          For i:=First to Last do begin
           Seek (f,i-1);
           Read(f,p);
           With p do begin
            Write(Lst,i:3);
            test:=name+'               ';
            Write(Lst,' ',test);
            test:=surname+'                ';
            Write(Lst,test,' ');
            With birthdate do begin
              Str(Day:2,test);
              Write(Lst,test,'/');
              Str(Month:2,test);
              Write(Lst,test,'/');
              Str(Year:4,test);
              Write(Lst,test);
            End;
            If Upcase(sex)='F' then Write(Lst,' Female ')
                               else Write(Lst,' Male   ');
            temp2:=id+'        ';
            Write(Lst,temp2);
            Str(salary:7:0,temp2);
            Write(Lst,temp2,'  ');
            Writeln(Lst,phone);
           end;{with}

           If (i mod 64)=0 then
Writeln(Lst,{#12,}'No. Name           Surname          Born      Sex    Id       Salary    Phone');
          end;{for}
          Writeln (lst{,#12});
          GoToXY(10,15); Write ('Press Any Key to Continue');
          Readkey;
          Seek(F,0);
     end{if};
End{Print};

{*****************************************************************}

Procedure Sorting;
Type PerPoint = ^Person;
Var n,i,j : Integer;
    R : Array[0..999] of PerPoint;
    Temp : PerPoint;

  Function IsBigger(Var p,q : Person) : Boolean;
  Begin
     IsBigger := p.Surname>q.Surname
  End;

Begin
  If not Opened then Warning
  Else begin
   n := FileSize(F)-1;  { Last record }

   { Reading records to RAM: }
   For i:=0 to n do begin
      New(R[i]);
      Seek(F,i);
      Read(F,R[i]^);
   end{for};

   { Selection sort: }
   For i:=0 to n-1 do
      For j:=i+1 to n do
         If IsBigger(R[i]^,R[j]^) then begin    { Swap }
            Temp := R[i];
            R[i] := R[j];
            R[j] := Temp
         end{if};

   { Writing records back to F: }
   For i:=0 to n do begin
      Seek(F,i);
      Write(F,R[i]^);
      Dispose(R[i]);
   end{for};
  End{if};
End{Sorting};

{********************** program body *************************}

Begin
   Opened := True;
   Assign (F,DFName);
   FileName := DFName;
   {$I-} Reset(F); {$I+}       { Attempt to open default file }
   If IOResult <> 0 then begin                       { not OK }
      ClrScr; GoToXY(2,10);
      Write ('Default file ',DFName,
             ' not open! Press enter to continue.');
      ReadLn;
      Opened := False
   end{if};
   Repeat                                         { MAIN LOOP }
      DispMenu;                      { Displays the main menu }
      Repeat                        { Reading the menu option }
          Option:=UpCase(ReadKey)
      Until Option in ['O','A','U','D','S','P','R','Q'];
      TextColor(Green);
      Case Option of
      'O': OpenFile;
      'A': Add;
      'U': Update;
      'D': Delete;
      'S': Show;
      'P': Print;
      'R': Sorting;
      'Q': By_screen;
      End{case}
   Until Option = 'Q';
End.
